
#include <X11/Xlib.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv)
{
	Display* dpy = XOpenDisplay(NULL);

	unsigned int width = 700;
	unsigned int height = 500;

	Window w = XCreateSimpleWindow(dpy, DefaultRootWindow(dpy), 0, 0, width, height, 2, 0, 0xffffff);
	XMapRaised(dpy, w);

	XGCValues gcattr;
	gcattr.foreground = 0;
	GC gc = XCreateGC(dpy, w, GCForeground, &gcattr);
	XFlush(dpy);

	sleep(1);

	printf("about to grab\n");

	XGrabServer(dpy);
	XFlush(dpy);

	printf("grabbed\n");

#ifdef FOREVER
	while(1) {
#endif
		XClearWindow(dpy, w);
		for (unsigned i = 0; i < width; i++) {
			XDrawLine(dpy, w, gc, i, 0, width-i, height);
			XFlush(dpy);
			usleep( 10000000 / width );
		}
#ifdef FOREVER
	}
#endif

	XUngrabServer(dpy);
	XFlush(dpy);
	printf("ungrabbed\n");

	XCloseDisplay(dpy);

	return 0;
}
